/* Jentchina - CnlCacheAndBank
 * STRASSER Michel - 20040329		init
 * */

#ifndef __JNA_CNL_CACHE_AND_BANK_H__
#define __JNA_CNL_CACHE_AND_BANK_H__

#include <glib.h>
#include <glib-object.h>


#define	JNA_TYPE_CNL_CACHE_AND_BANK			(JnaCnlCacheAndBank_getType ())
#define JNA_CNL_CACHE_AND_BANK(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_CNL_CACHE_AND_BANK, JnaCnlCacheAndBank))
#define JNA_CNL_CACHE_AND_BANK_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_CNL_CACHE_AND_BANK, JnaCnlCacheAndBankClass))
#define JNA_IS_CNL_CACHE_AND_BANK(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_CNL_CACHE_AND_BANK))
#define JNA_IS_CNL_CACHE_AND_BANK_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_CNL_CACHE_AND_BANK))
#define JNA_CNL_CACHE_AND_BANK_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_CNL_CACHE_AND_BANK_TYPE_NAME(object)	  (g_type_name (JNA_CNL_CACHE_AND_BANK_TYPE (object)))

typedef struct _JnaCnlCacheAndBank	JnaCnlCacheAndBank;
typedef struct _JnaCnlCacheAndBankClass	JnaCnlCacheAndBankClass;

struct _JnaCnlCacheAndBank
{
	GObject 		parent_instance;
	GHashTable*		coms;
	char*			appName;
	char* 			cacheDir;
};

struct _JnaCnlCacheAndBankClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaCnlCacheAndBank_getType		(void);


GObject* 	
JnaCnlCacheAndBank_new			(char* appName);

/* returns FALSE if already registered */
gboolean
JnaCnlCacheAndBank_registerServer	(JnaCnlCacheAndBank* self,
					 GObject* com,
					 GObject* server, 	/* JnaXServerInfoReader */
					 GObject* stream);	/* JnaCnlStream */

char*	/* newly allocated */
JnaCnlCacheAndBank_getRessource		(JnaCnlCacheAndBank* self,
					 char* serverDomain,
					 char* serverId,
					 char* ressource);

// returns NULL if not registered
GObject*
JnaCnlCacheAndBank_getCom		(JnaCnlCacheAndBank* self,
					 char* domain,
					 char* id);


G_END_DECLS

#endif /* __JNA_CNL_CACHE_AND_BANK_H__ */
