/* Jentchina - Grabber
 * STRASSER Michel - 20040329		init
 * */



#ifndef __JNA_GRABBER_H__
#define __JNA_GRABBER_H__

#include <glib.h>
#include <glib-object.h>
#include <lsmlib.h>

#define	JNA_TYPE_GRABBER			(JnaGrabber_getType ())
#define JNA_GRABBER(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_GRABBER, JnaGrabber))
#define JNA_GRABBER_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_GRABBER, JnaGrabberClass))
#define JNA_IS_GRABBER(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_GRABBER))
#define JNA_IS_GRABBER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_GRABBER))
#define JNA_GRABBER_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_GRABBER_TYPE_NAME(object)	  (g_type_name (JNA_GRABBER_TYPE (object)))

typedef struct _JnaGrabber	JnaGrabber;
typedef struct _JnaGrabberClass	JnaGrabberClass;

struct _JnaGrabber
{
	GObject 		parent_instance;
	GObject*		jentchina;
	char* 			appName;
	GObject* 		serversListReader;	/* JnaXServersListReader */
	GObject*		comFactory;		/* JnaComFactory */
	GHashTable*		checkSumHash;		/* indexed by ckecksum */
	int			maxRecurse;
};

struct _JnaGrabberClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaGrabber_getType		(void);


GObject* 	
JnaGrabber_new			(GObject* jentchina, // JnaCnlJentchina
				 int maxNAgents,
				 char* appName);

G_END_DECLS

#endif /* __JNA_GRABBER_H__ */
