#include <glib.h>
#include "JnaXCommon.h"
#include <string.h>

// newly allocated
char*
JnaXCommon_getRadical		(char* xmlFile)
{
	char* retval;
	char* base;
	char* begin;
	char* end;
	int l;

	base=g_path_get_basename(xmlFile);
	g_return_val_if_fail(base, NULL);
	begin=strstr(base, "-")+1;
	g_return_val_if_fail(begin, NULL);
	end=strstr(begin, ".");
	g_return_val_if_fail(end, NULL);

	l=(int)end-(int)begin;
	retval=g_strndup(begin, l);

	g_free(base);

	return retval;
}

