/* Jentchina - XFilterDescriptionReadersListReader - Xml reader helping object
 * STRASSER Michel - 20040301		init
 * */
#ifndef __JNA_X_FILTER_DESCRIPTION_READER_H__
#define __JNA_X_FILTER_DESCRIPTION_READER_H__

#include <glib.h>
#include <glib-object.h>

#define	JNA_TYPE_X_FILTER_DESCRIPTION_READER			(JnaXFilterDescriptionReader_getType ())
#define JNA_X_FILTER_DESCRIPTION_READER(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_X_FILTER_DESCRIPTION_READER, JnaXFilterDescriptionReader))
#define JNA_X_FILTER_DESCRIPTION_READER_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_X_FILTER_DESCRIPTION_READER, JnaXFilterDescriptionReaderClass))
#define JNA_IS_X_FILTER_DESCRIPTION_READER(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_X_FILTER_DESCRIPTION_READER))
#define JNA_IS_X_FILTER_DESCRIPTION_READER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_X_FILTER_DESCRIPTION_READER))
#define JNA_X_FILTER_DESCRIPTION_READER_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_X_FILTER_DESCRIPTION_READER_TYPE_NAME(object)	  (g_type_name (JNA_X_FILTER_DESCRIPTION_READER_TYPE (object)))

typedef struct _JnaXFilterDescriptionReader	JnaXFilterDescriptionReader;
typedef struct _JnaXFilterDescriptionReaderClass	JnaXFilterDescriptionReaderClass;

struct _JnaXFilterDescriptionReader
{
	GObject 		parent_instance;
	char* 			id;
	GList*			authors;
	int 			version;
	char* 			year;
	char* 			license;
	char* 			application;
	char* 			info;
};

struct _JnaXFilterDescriptionReaderClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaXFilterDescriptionReader_getType		(void);


/* you can free xmlFile after calling this constructor */
GObject* 	
JnaXFilterDescriptionReader_new			(char* xmlFile);

/* newly allocated */
char*
JnaXFilterDescriptionReader_toString		(JnaXFilterDescriptionReader* self);

void
JnaXFilterDescriptionReader_print		(JnaXFilterDescriptionReader* self);


G_END_DECLS

#endif /* __JNA_X_FILTER_DESCRIPTION_READER_H__ */
